/**
 * @file Main.cpp
 * @date 2015-06-21
 * @brief Tv\[XR[h
 */
// for June2015v2

#include "modelconverter.hpp"
#include "pmd.hpp"

#include "HamFramework\SceneManager.hpp"

#define FSL L"Large"
#define FSM L"Medium"
#define FSS L"Small"

#define AXISH (0.25)
#define AXISI (5.0)

/// <summary>ŜŎgp</summary>
struct Data {
	/// <summary>GUIz</summary>
	Array<GUI> guis;
	/// <summary>^C}[</summary>
	TimerMillisec timerMilli;

	/// <summary>ϊѕ`p</summary>
	Array<ModelConverter> converters;
	/// <summary>CX^X1</summary>
	Array<MotionInstance> mis;

	/// <summary>]</summary>
	double ang = 0;
	/// <summary>ݒUI</summary>
	bool uiVisibled[4];

	/// <summary>bZ[Wp</summary>
	Effect effect;


	/// <summary></summary>
	void btMake(bool enabled) {
		guis[0].button(L"bt_make").enabled = enabled;
	}
};

using MyApp = ham::SceneManager<String,Data>;

/// <summary>bZ[W\</summary>
struct Message : IEffect {
	String msg;
	/// <summary>YW</summary>
	int my = 100;
	/// <summary>RXgN^</summary>
	Message(String inMsg) {
		msg = inMsg;
	}
	/// <summary>XV</summary>
	bool update(double t) override {
		double alpha = 1.0;
		if (t < 1.0) {
			alpha = t;
		}
		else if (t > 4.0) {
			alpha = 5.0 - t;
		}
		ColorF c0(Palette::White,alpha);
		ColorF c1(Palette::Black,alpha);

		int y = my - (int)Math::Floor(t*20);

		FontAsset(FSS)(msg).drawCenter(y+2, c1);
		FontAsset(FSS)(msg).drawCenter(y, c0);
		return t < 5.0;
	}
};

/// <summary>X^[gAbv</summary>
struct Startup : MyApp::Scene {
	/// <summary></summary>
	void init() override {
		FontAsset::Register(FSL, 48, Typeface::Black, FontStyle::Outline);
		FontAsset::Register(FSM, 32, Typeface::Black, FontStyle::Outline);
		FontAsset::Register(FSS, 16, Typeface::Black, FontStyle::Outline);

		FontAsset(FSL).changeOutlineStyle({ Palette::Midnightblue, Palette::Whitesmoke, 3 });
		FontAsset(FSM).changeOutlineStyle({ Palette::Black, Palette::White, 2 });
		FontAsset(FSS).changeOutlineStyle({ Palette::Black, Palette::White, 1 });


		Window::SetTitle(L".mqo.pmdϊ 3");
		Window::SetStyle(WindowStyle::Sizeable);
		Dragdrop::SetEnabled(true);

		Window::Resize({800,600});

		Camera cam = Graphics3D::GetCamera();
		cam.pos = { 0, 25, -80 };
		cam.lookat = { 0, 20, 0 };
		Graphics3D::SetCamera(cam);

		m_data->timerMilli.start();

		GUI gui(GUIStyle::Default);
		gui.setTitle(L"ݒ");

		gui.add(L"tx_fps", GUIText::Create(L"-"));
		gui.add(GUIText::Create(L"fps"));
		gui.add(GUIText::Create(L"JE^"));
		gui.addln(L"tx_counter", GUIText::Create(L"-"));

		gui.add(GUIHorizontalLine::Create());

		gui.addln(L"rb_deci", GUIRadioButton::Create({ L"1{", L"0.125{", L"0.1{" },1u));

		gui.add(L"bt_open", GUIButton::Create(L"J"));
		gui.addln(L"bt_clear", GUIButton::Create(L"NA"));

		gui.add(GUIHorizontalLine::Create());

		gui.addln(L"bt_make", GUIButton::Create(L"pmdo"));

		Rect rc = gui.getRect();
		gui.setPos(Window::Width() - rc.w - 4, Window::Height() - rc.h - 4);
		gui.hide();

		m_data->guis.push_back(gui);
		m_data->btMake(false);

// IvVUI
		GUI gui1(GUIStyle::Default);
		gui1.setTitle(L"͐ݒ");
		gui1.addln(L"cb_dblface", GUICheckBox::Create({ L"ʑfނ͖ʒǉɂ" }));

		gui1.setPos(4, 4);
		gui1.hide();
		m_data->guis.push_back(gui1);

// ^
		GUI gui2(GUIStyle::Default);
		gui2.setTitle(L"vr[ݒ");

		gui2.add(GUIText::Create(L"ӏƖ"));
		gui2.add(L"sl_amb", GUISlider::Create(0, 100, 50));
		gui2.addln(L"tx_amb", GUIText::Create(L"0.50"));
		Graphics3D::SetAmbientLight(ColorF(0.50));

		gui2.add(L"cb_axis", GUICheckBox::Create({ L"ڐ\" }));
		gui2.addln(L"bt_bgc", GUIButton::Create(L"wiF"));

		gui2.add(L"cb_wire", GUICheckBox::Create({ L"C[t[\" }));
		gui2.addln(L"cb_rot", GUICheckBox::Create({ L"]" }));

		rc = gui2.getRect();
		gui2.setPos((Window::Width() - rc.w) / 2, 4);
		gui2.hide();
		m_data->guis.push_back(gui2);

// E
		GUI gui3(GUIStyle::Default);
		gui3.setTitle(L"o͐ݒ");

		String s = L"fpݒ𔽉f";
		gui3.addln(L"cb_settings", GUICheckBox::Create({s}));
		s = L"fpRg𔽉f";
		gui3.addln(L"cb_comment", GUICheckBox::Create({ s }));

		rc = gui3.getRect();
		gui3.setPos(Window::Width() - rc.w - 4, 4);
		gui3.hide();
		m_data->guis.push_back(gui3);

		m_data->uiVisibled[0] = true;
		m_data->uiVisibled[1] = false;
		m_data->uiVisibled[2] = false;
		m_data->uiVisibled[3] = true;
	}
	/// <summary>XV</summary>
	void update() override {
		changeScene(L"MainScene");
	}
	/// <summary>`</summary>
	void draw() const override {
		FontAsset(FSM)(L"Please wait a minutes...").drawCenter(100);
	}

};

/// <summary>CV[</summary>
struct MainScene : MyApp::Scene {
	/// <summary></summary>
	void init() override {
		for (int i = 0; i < 4; ++i) {
			m_data->guis[i].show(m_data->uiVisibled[i]);
		}
	}
	/// <summary>XV</summary>
	void update() override {
		Graphics3D::FreeCamera();

		bool isRot = m_data->guis[2].checkBox(L"cb_rot").checked(0);
		if (isRot) {
			m_data->ang += 0.01;
			m_data->ang += Math::TwoPi / 3600.0;
		}

		m_data->guis[0].text(L"tx_fps").text = ToString(Profiler::FPS());
		m_data->guis[0].text(L"tx_counter").text = ToString(System::FrameCount());

		if (m_data->guis[2].slider(L"sl_amb").hasChanged) {
			auto lv = m_data->guis[2].slider(L"sl_amb").valueInt;
			m_data->guis[2].text(L"tx_amb").text = Format(lv / 100, L".", Pad<int>(lv % 100, {2,'0'}));
			Graphics3D::SetAmbientLight(ColorF(0.01 * (double)lv));
		}

		if (Input::KeyF1.clicked) {
			String path = FileSystem::ParentPath(FileSystem::ModulePath()) + L"readme.txt";
			System::LaunchFile(path, LaunchVerb::Open);
		}

		if (Input::KeyF6.clicked) {
			m_data->uiVisibled[1] = !m_data->uiVisibled[1];
			m_data->guis[1].show(m_data->uiVisibled[1]);
		}
		if (Input::KeyF7.clicked) {
			m_data->uiVisibled[2] = !m_data->uiVisibled[2];
			m_data->guis[2].show(m_data->uiVisibled[2]);
		}
		if (Input::KeyF8.clicked) {
			m_data->uiVisibled[3] = !m_data->uiVisibled[3];
			m_data->guis[3].show(m_data->uiVisibled[3]);
		}

		if (Input::KeyF9.clicked) {
			m_data->uiVisibled[0] = !m_data->uiVisibled[0];
			m_data->guis[0].show(m_data->uiVisibled[0]);
		}

		if (m_data->guis[2].checkBox(L"cb_wire").hasChanged) {
			if (m_data->guis[2].checkBox(L"cb_wire").checked(0)) {
				Graphics3D::SetRasterizerState(RasterizerState::WireframeNone);
			}
			else {
				Graphics3D::SetRasterizerState(RasterizerState::Default3D);
			}
		}

		if (m_data->guis[2].button(L"bt_bgc").pushed) {
			auto c = Dialog::GetColor();
			if (c) {
				Graphics::SetBackground(c.value());
			}
		}
		if (m_data->guis[0].button(L"bt_clear").pushed
			|| Input::KeyDelete.clicked) {
			this->ClearModel();
		}
		if (m_data->guis[0].button(L"bt_open").pushed) {
			if (auto open = Dialog::GetOpen({ {L"Model(*.mqo)",L"*.mqo"},
				{L"All",L"*.*"} })) {
				OpenMqo(open.value());
			}
		}

		if (Dragdrop::HasItems()) {
			auto paths = Dragdrop::GetFilePaths();
			for (auto path : paths) {
				OpenMqo(path);
			}
		}

		if (m_data->guis[0].button(L"bt_make").pushed) {
			bool result = OutputPmd();
			if (result) {
				m_data->effect.add<Message>(L"o͂܂");
			}
			else {
				m_data->effect.add<Message>(L"s܂");
			}
		}

		for (auto& mi : m_data->mis) {
			if (mi.optIdx == false) {
				continue;
			}
			// [VKp
			for (int i = 0; i < mi.nodes.size(); ++i) {
				auto& node = mi.nodes[i];
				double ang = (isRot) ? m_data->ang : 0;
				node.motionRot = Quaternion::Yaw(ang);
			}
			mi.ComputeCurCoordinates();
		}

		m_data->effect.update();
	}
	/// <summary>`</summary>
	void draw() const override {
		if (m_data->guis[2].checkBox(L"cb_axis").checked(0)) {
			Box({-AXISH,-AXISH,-AXISH}, AXISH * 2).draw(Palette::Yellow);
			for (int i = 1; i <= 10; ++i) {
				Cone(i*5, -AXISH*2, 0, AXISH, AXISH * 2).draw(Palette::Red);
				Cone(-AXISH*2, i*5, 0, AXISH, AXISH * 2,
					Quaternion::Roll(-HalfPi)).draw(Palette::Green);
				Cone(0, -AXISH*2, i*5, AXISH, AXISH * 2).draw(Palette::Mediumblue);
			}
		}

		for (auto& mi : m_data->mis) {
			if (mi.optIdx == false) {
				continue;
			}
			int idx = mi.optIdx.value();
			if (idx >= m_data->converters.size()) {
				continue;
			}
			const auto& mc = m_data->converters[idx];
			int matNum = mc.mats.size();

			for (int i = 0; i < mi.nodes.size(); ++i) {
				if (mc.meshes[i].isEmpty) {
					//Println(L"̃bV, ", i);
					continue;
				}

				const auto& node = mi.nodes[i];
				Mat4x4 cur = node.GetCurMat();

				for (int j = 0; j < matNum; ++j) {
					if (j >= node.groups.size()) {
						continue;
					}
					const auto& gr = node.groups[j];
					if (gr.num() <= 0) {
						continue;
					}

					const auto& mat = mc.mats[j];
					Vec3 v3(mat.diffuse.r + mat.ambient.r + mat.emission.r,
						mat.diffuse.g + mat.ambient.g + mat.emission.g,
						mat.diffuse.b + mat.ambient.b + mat.emission.b);
					ColorF c(Clamp(v3, 0, 1));

					if (i >= mc.meshes.size()) {
						//Println(L"bVCfbNXG[ ",
						//	i,L" ",j,L" ",mc.meshes.size(),L" ",mc.mats.size());
						continue;
					}

					mc.meshes[i].drawSubset(gr.offset,
						gr.num(),
						cur,
						mc.texs[j],
						c);
				}
			}
		}

	}

	/// <summary>f̓ǂݏoԂNA</summary>
	void ClearModel() {
		ClearPrint();
		m_data->converters.clear();
		m_data->mis.clear();
		m_data->btMake(false);
	}

	/// <summary>.mqot@Cǂݍ݃fpӂ</summary>
	void OpenMqo(String inPath) {
		this->ClearModel();

		TextReader r;
		bool result = r.open(inPath);
		if (result == false) {
			m_data->effect.add<Message>(L"I[vɎs܂");
			return;
		}

		ModelConverter mc;

		MqoFile mqo;
		mqo.clear();
		mqo.path = inPath;
		MqoFiler filer;
		result = filer.LoadMqo(r,mqo);
		if (result == false) {
			m_data->effect.add<Message>(L"[hɎs܂");
			return;
		}

		Array<String> options;
		if (m_data->guis[1].checkBox(L"cb_dblface").checked(0)) {
			options.push_back(L"addFaceForDouble");
		}
		double rates[] = { 1.0, 0.125, 0.1 };
		double rate = rates[m_data->guis[0].radioButton(L"rb_deci").checkedItem.value()];

		result = mc.ApplyMqo(mqo,rate,options);
		if (result) {
			MotionInstance mi = mc.CreateMotionInstance();
			mi.optIdx.emplace(m_data->converters.size());

			m_data->converters.push_back(mc);
			m_data->mis.push_back(mi);

			m_data->effect.add<Message>(L"\܂");
			for (const auto& l : mqo.scene.dirlights) {
				Light dir = Light::Directional(rev_z(l.dir),l.color);
				Graphics3D::SetLight(0, dir);
			}
			m_data->btMake(true);
		}
		else {
			m_data->effect.add<Message>(L"s܂");
		}
	}

	/// <summary>e{[+̖Õ{[\{[ɂ</summary>
	/// <remarks>ʂȃt@Cֈړ邩B</remarks>
	/// <param name="f">ύXΏۂ̃t@CQ</param>
	void hideTail(PmdFile& f) const {
		for (auto& bone : f.bones) {
			int index = bone.parent;
			if (index >= 0 && index < f.bones.size()) {
				if (f.bones[index].name + L"" == bone.name) {
					bone.type = PMDBONE_HIDE;
				}
			}
		}
	}


	/// <summary>IKݒt@Cݒ肷</summary>
	/// <remarks>ƂŃt@C̏ꏊς邩Ȃ</remarks>
	/// <param name="path">ݒt@CtpX</param>
	bool setIks(PmdFile& f, const String path) const {
		XMLReader xr(path);
		if (xr.isValid() == false) {
			return false;
		}

		for (auto& elm = xr.root().firstChild(); elm.isNull() == false; elm = elm.nextSibling()) {
			if (elm.name == L"iks") {
				for (auto& ik = elm.firstChild(); ik.isNull() == false; ik = ik.nextSibling()) {
					if (ik.name != L"ik") {
						continue;
					}

					PmdIk pmdIk;
					String name = ik.attribute(L"name").value_or(L"");
					String target = ik.attribute(L"target").value_or(L"");

					pmdIk.ikBoneIndex = f.getBoneIndexByName(name);
					pmdIk.targetIndex = f.getBoneIndexByName(target);
					if (pmdIk.ikBoneIndex < 0 || pmdIk.targetIndex < 0) {
						continue;
					}

					pmdIk.iterations = Parse<int>(ik.attribute(L"iterations").value_or(L"0"));
					pmdIk.control = Parse<float>(ik.attribute(L"control").value_or(L"0.5"));
					for (auto& children = ik.firstChild(); children.isNull() == false; children = children.nextSibling()) {
						if (children.name != L"children") {
							continue;
						}

						for (auto& child = children.firstChild(); child.isNull() == false; child = child.nextSibling()) {
							if (child.name != L"child") {
								continue;
							}
							int childIndex = f.getBoneIndexByName(child.text);
							if (childIndex >= 0) {
								pmdIk.childBones.push_back(childIndex);
							}
						}
					}
					f.iks.push_back(pmdIk);

					{ // o{[̎ނύX
						f.bones[pmdIk.ikBoneIndex].type = PMDBONE_IK;
						f.bones[pmdIk.targetIndex].type = PMDBONE_IKCONNECT;
						for (const auto& childIndex : pmdIk.childBones) {
							f.bones[childIndex].type = PMDBONE_UNDERIK;
						}
					}

				}
			}
		}
		return true;
	}

	/// <summary>ݒt@Cݒ肷</summary>
	/// <remarks>ƂŃt@C̏ꏊς邩Ȃ</remarks>
	/// <param name="path">ݒt@CtpX</param>
	bool setBones(PmdFile& f, const String path) const {
		XMLReader xr(path);
		if (xr.isValid() == false) {
			return false;
		}

		for (auto& elm = xr.root().firstChild(); elm.isNull() == false; elm = elm.nextSibling()) {
			if (elm.name == L"bones") {
				for (auto& bone = elm.firstChild(); bone.isNull() == false; bone = bone.nextSibling()) {
					if (bone.name != L"bone") {
						continue;
					}

					String name = bone.attribute(L"name").value_or(L"");
					int boneIndex = f.getBoneIndexByName(name);
					if (boneIndex < 0) {
						continue;
					}
					int type = Parse<int>(bone.attribute(L"type").value_or(L""));
					if (type < 0 && type > 9) {
						continue;
					}

					if (type == PMDBONE_UNDERROT) {
						String rotParent = bone.attribute(L"rot-parent").value_or(L"");
						int rotParentIndex = f.getBoneIndexByName(rotParent);
						if (rotParentIndex < 0) {
							continue;
						}
						f.bones[boneIndex].optionParent = rotParentIndex;
					}
					else if (type == PMDBONE_RATINGROT) {
						String rotParent = bone.attribute(L"rot-parent").value_or(L"");
						int rotParentIndex = f.getBoneIndexByName(rotParent);
						if (rotParentIndex < 0) {
							continue;
						}
						String rotPercentage = bone.attribute(L"rot-percentage").value_or(L"");
						int percentage = Parse<int>(rotPercentage);
						f.bones[boneIndex].child = rotParentIndex;
						f.bones[boneIndex].optionParent = percentage;
					}
					f.bones[boneIndex].type = type;

					for (auto& elm3 = bone.firstChild(); elm3.isNull() == false; elm3 = elm3.nextSibling()) {
						if (elm3.name == L"rigid") {
							PmdBody b;
							b.name = elm3.attribute(L"name").value_or(f.bones[boneIndex].name);
							b.type = Parse<int>(elm3.attribute(L"calc").value_or(L"0"));
							b.shape = Parse<int>(elm3.attribute(L"shape").value_or(L"0"));
							b.group = Parse<int>(elm3.attribute(L"group").value_or(L"1"));

							b.size = Vec3(1, 1, 1);

							b.wt = Parse<double>(elm3.attribute(L"weight").value_or(L"1.0"));
							b.friction = Parse<double>(elm3.attribute(L"friction").value_or(L"0.0"));
							b.pong = Parse<double>(elm3.attribute(L"reflection").value_or(L"1.0"));
							b.movAttenuation = Parse<double>(elm3.attribute(L"movAttenuation").value_or(L"0.0"));
							b.rotAttenuation = Parse<double>(elm3.attribute(L"rotAttenuation").value_or(L"0.0"));

							b.colli = 0;
							for (auto& hits = elm3.firstChild(); hits.isNull() == false; hits = hits.nextSibling()) {
								if (hits.name != L"hits") {
									continue;
								}
								for (auto& hit = hits.firstChild(); hit.isNull() == false; hit = hit.nextSibling()) {
									int id = Parse<int>(hit.text);
									if (id >= 1 && id <= 16) {
										b.colli |= (1 << (id - 1));
									}
								}
							}

							String base = elm3.attribute(L"base").value_or(L"bone");
							b.position = f.bones[boneIndex].position;
							if (base == L"origin") {
								b.position = Vec3();
							}
							else if (base == L"midpoint") {
								int child = f.bones[boneIndex].child;
								if (child > 0) {
									b.position = (b.position + f.bones[child].position) * 0.5;
								}
							}
							f.bodies.push_back(b);
						}

					}
				}
			}
		}
		return true;
	}

	/// <summary>t@CŜRgɊi[</summary>
	bool setCommentFile(PmdFile& f, const String path) const {
		TextReader tr(path);
		if (tr.isOpened()) {
			f.comment = tr.readContents();
			return true;
		}
		return false;
	}

	/// <summary>t@CŜpRgɊi[</summary>
	bool setEnCommentFile(PmdFile& f, const String path) const {
		TextReader tr(path);
		if (tr.isOpened()) {
			f.commentE = tr.readContents();
			return true;
		}
		return false;
	}

	/// <summary>fZbg</summary>
	bool setHeader(PmdFile& f, const String path) const {
		XMLReader xr(path);
		if (xr.isValid() == false) {
			return false;
		}

		for (auto& elm = xr.root().firstChild(); elm.isNull() == false; elm = elm.nextSibling()) {
			if (elm.name == L"header") {
				for (auto& frame = elm.firstChild(); frame.isNull() == false; frame = frame.nextSibling()) {
					if (frame.name == L"model-name") {
						f.name = frame.text;
					}
					if (frame.name == L"model-name-en") {
						f.nameE = frame.text;
					}
				}
			}
		}
		return true;
	}

	/// <summary>\g蒼</summary>
	bool setFrames(PmdFile& f, const String path) const {
		XMLReader xr(path);
		if (xr.isValid() == false) {
			return false;
		}

		f.frames.clear();

		std::list<int> bones;
		for (int i = 1; i < f.bones.size(); ++i) {
			bones.push_back(i);
		}

		int count = 0;
		for (auto& elm = xr.root().firstChild(); elm.isNull() == false; elm = elm.nextSibling()) {
			if (elm.name == L"frames") {
				for (auto& frame = elm.firstChild(); frame.isNull() == false; frame = frame.nextSibling()) {
					if (frame.name == L"frame" || frame.name == L"hide") {
						PmdFrame fr;
						for (auto& bone = frame.firstChild(); bone.isNull() == false; bone = bone.nextSibling()) {
							if (bone.name != L"in") {
								continue;
							}
							int index = f.getBoneIndexByName(bone.text);
							if (index < 0) {
								continue;
							}
							fr.bones.push_back(index);
							bones.remove(index);
						}
						if (frame.name == L"frame") {
							String s = L"bones" + Pad(count + 1, { 3, L'0' });
							fr.name = frame.attribute(L"name").value_or(s);
							fr.nameE = s;
							f.frames.push_back(fr);
							++count;
						}

					}
				}

				int enumNumber = Parse<int>(elm.attribute(L"enum-number").value_or(L"0"));
				if (enumNumber >= 1) {
					// {[\g
					int adjustBoneNum = bones.size();
					if (adjustBoneNum < 0) {
						adjustBoneNum = 0;
					}
					int frameNum = (adjustBoneNum + enumNumber - 1) / enumNumber;
					if (frameNum > 255 - f.frames.size()) {
						frameNum = 255 - f.frames.size(); // ő
					}
					auto it = bones.begin();
					for (int i = 0; i < frameNum; ++i) {
						PmdFrame frame;
						String s = L"bones" + Pad(count + 1, { 3, L'0' });
						frame.name = s;
						frame.nameE = s;
						for (int j = 0; j < enumNumber; ++j) {
							if (it == bones.end()) {
								break;
							}
							frame.bones.push_back(*it);
							++it;
						}
						f.frames.push_back(frame);
						++count;
					}

				}

			}
		}
		return true;
	}

	/// <summary>.pmdt@Co͂</summary>
	bool OutputPmd() {
		if (m_data->converters.size() < 1) {
			return false;
		}

		PmdFile pmd;
		bool result = m_data->converters[0].ConvertToPmd(pmd);
		if (result == false) {
			return false;
		}

		// ␳
		hideTail(pmd);

		String modelPath = m_data->converters[0].path;
		String modelDir = FileSystem::ParentPath(modelPath);
		String modelPathBase = modelDir + L"/" + FileSystem::BaseName(modelPath);

		String settingsFile(modelPathBase + L".xml");
		if (m_data->guis[3].checkBox(L"cb_settings").checked(0)) {
			setBones(pmd, settingsFile);
			setIks(pmd, settingsFile);
			setFrames(pmd, settingsFile);
			setHeader(pmd, settingsFile);
		}

		if (m_data->guis[3].checkBox(L"cb_comment").checked(0)) {
			setCommentFile(pmd, modelPathBase + L"_ja.txt");
			setEnCommentFile(pmd, modelPathBase + L"_en.txt");
		}


		auto outPath = Dialog::GetSave({ { L"pmdt@C(*.pmd)", L"*.pmd" } });
		if (!outPath) {
			return false;
		}

		PmdFiler pmdFiler;
		BinaryWriter w(outPath.value());
		result = pmdFiler.SavePmd(pmd,w);
		if (result == false) {
			return false;
		}
		return true;
	}
};

/// <summary>C֐</summary>
void Main() {
	MyApp myApp;
	myApp.add<Startup>(L"Startup");
	myApp.add<MainScene>(L"MainScene");
	while (System::Update()) {
		if (!myApp.updateAndDraw()) {
			break;
		}
	}
}
